/**********************************************************************
 *<
	FILE: BumpBlend.cpp

	DESCRIPTION:	Appwizard generated plugin

	CREATED BY: 

	HISTORY: 

 *>	Copyright (c) 1997, All Rights Reserved.
 **********************************************************************/

#include "BumpBlend.h"

#define BUMPBLEND_CLASS_ID	Class_ID(0x2e59d938, 0x46c99dbd)

#define NSUBTEX		10 // TODO: number of sub-textures supported by this plugin 
#define PBLOCK_REF	0



class BumpBlend;

enum { bumpblend_params };

// compmat_params param IDs

enum 
{ 
	compmat_mtls,
	compmat_map_on, 
	compmat_amount
};


class BumpBlend : public Texmap {
	public:
		// Parameter block
		IParamBlock2	*pblock;	//ref 0
		Texmap			*subtex[NSUBTEX]; //array of sub-materials
		Texmap			*masktex[NSUBTEX]; //array of sub-materials
		float			amounts[NSUBTEX];
		BOOL			ons[NSUBTEX];
		Interval		ivalid;

		//From MtlBase
		ParamDlg* CreateParamDlg(HWND hwMtlEdit, IMtlParams *imp);
		BOOL SetDlgThing(ParamDlg* dlg);
		void Update(TimeValue t, Interval& valid);
		void Reset();
		Interval Validity(TimeValue t);
		ULONG LocalRequirements(int subMtlNum);

		//TODO: Return the number of sub-textures
		int NumSubTexmaps() { return NSUBTEX*2; }
		//TODO: Return the pointer to the 'i-th' sub-texmap
		Texmap* GetSubTexmap(int i) { 
								Texmap *sm1 = NULL;
								Interval iv;
								pblock->GetValue(compmat_mtls,0,sm1,iv,i);
								return sm1; 
								}
		void SetSubTexmap(int i, Texmap *m)
								{
								if (i< 20)   //watje 3-18-99 to prevent the base material from getting nulled
									pblock->SetValue(compmat_mtls,0,m,i);
								}
		TSTR GetSubTexmapSlotName(int i)
								{
								Texmap *sm1 = NULL;
								Interval iv;
								pblock->GetValue(compmat_mtls,0,sm1,iv,i);
								TSTR name;
								if (sm1 != NULL)
									name.printf("%s %d",GetString(IDS_PW_MAT),i);
								else name.printf("empty %d",i);
								return name; 
								}
		
		//From Texmap
		RGBA EvalColor(ShadeContext& sc);
		float EvalMono(ShadeContext& sc);
		Point3 EvalNormalPerturb(ShadeContext& sc);

		XYZGen *GetTheXYZGen() { return NULL; } 
		
		//TODO: Return anim index to reference index
		int SubNumToRefNum(int subNum) { return subNum; }
		
		
		// Loading/Saving
		IOResult Load(ILoad *iload);
		IOResult Save(ISave *isave);

		//From Animatable
		Class_ID ClassID() {return BUMPBLEND_CLASS_ID;}		
		SClass_ID SuperClassID() { return TEXMAP_CLASS_ID; }
		void GetClassName(TSTR& s) {s = GetString(IDS_CLASS_NAME);}
		
		RefTargetHandle Clone( RemapDir &remap );
		RefResult NotifyRefChanged(Interval changeInt, RefTargetHandle hTarget, 
			PartID& partID,  RefMessage message);

		int NumSubs() { return 1+NSUBTEX; }
		Animatable* SubAnim(int i); 
		TSTR SubAnimName(int i);
		int NumRefs() { return 1; }
		RefTargetHandle GetReference(int i);
		void SetReference(int i, RefTargetHandle rtarg);

		int	NumParamBlocks() { return 1; }					// return number of ParamBlocks in this instance
		IParamBlock2* GetParamBlock(int i) { return pblock; } // return i'th ParamBlock
		IParamBlock2* GetParamBlockByID(BlockID id) { return (pblock->ID() == id) ? pblock : NULL; } // return id'd ParamBlock
		void DeleteThis() { delete this; }		
		//Constructor/Destructor
		BumpBlend();
		~BumpBlend();		
};


class BumpBlendClassDesc:public ClassDesc2 {
	public:
	int 			IsPublic() {return 1;}
	void *			Create(BOOL loading = FALSE) {return new BumpBlend();}
	const TCHAR *	ClassName() {return GetString(IDS_CLASS_NAME);}
	SClass_ID		SuperClassID() {return TEXMAP_CLASS_ID;}
	Class_ID		ClassID() {return BUMPBLEND_CLASS_ID;}
	const TCHAR* 	Category() {return GetString(IDS_CATEGORY);}
	const TCHAR*	InternalName() { return _T("BumpBlend"); }	// returns fixed parsable name (scripter-visible name)
	HINSTANCE		HInstance() { return hInstance; }				// returns owning module handle
};

static BumpBlendClassDesc BumpBlendDesc;
ClassDesc2* GetBumpBlendDesc() {return &BumpBlendDesc;}



static ParamBlockDesc2 bumpblend_param_blk ( bumpblend_params, _T("params"),  0, &BumpBlendDesc, 
	P_AUTO_CONSTRUCT + P_AUTO_UI, PBLOCK_REF, 
	//rollout
	IDD_PANEL, IDS_PARAMS, 0, 0, NULL,
	// params
	// params
	compmat_mtls,		_T("textureList"),	TYPE_TEXMAP_TAB, 20,   P_SUBANIM,	IDS_RB_MATERIAL2,	
		p_subtexno, 0,
		p_ui,			TYPE_TEXMAPBUTTON, IDC_COMPMAT_MAT1, IDC_COMPMAT_MAT2, IDC_COMPMAT_MAT3,  IDC_COMPMAT_MAT4, 
										IDC_COMPMAT_MAT5, IDC_COMPMAT_MAT6,  IDC_COMPMAT_MAT7, 
										IDC_COMPMAT_MAT8, IDC_COMPMAT_MAT9, IDC_COMPMAT_MAT10, 
										IDC_COMPMAT_MAT11, IDC_COMPMAT_MAT12, IDC_COMPMAT_MAT13, 
										IDC_COMPMAT_MAT14, IDC_COMPMAT_MAT15, IDC_COMPMAT_MAT16, 
										IDC_COMPMAT_MAT17, IDC_COMPMAT_MAT18, IDC_COMPMAT_MAT19, IDC_COMPMAT_MAT20, 
		end,


	compmat_map_on,	_T("mapEnables"), TYPE_BOOL_TAB, 10, 0, IDS_MAPENABLE,
		p_default,		TRUE,
		p_ui,			TYPE_SINGLECHEKBOX, IDC_MAPON1, IDC_MAPON2, IDC_MAPON3, IDC_MAPON4, IDC_MAPON5,
											IDC_MAPON6, IDC_MAPON7, IDC_MAPON8, IDC_MAPON9, IDC_MAPON10,
		end,

	compmat_amount,  _T("amount"),		TYPE_FLOAT_TAB, 	10,P_ANIMATABLE|P_COMPUTED_NAME|P_TV_SHOW_ALL,	IDS_PW_AMOUNT, 
		p_default, 		100.0f,	
		p_range, 		0.00f, 100.0f, 
		p_ui, 			TYPE_SPINNER, EDITTYPE_FLOAT, 
						IDC_COMPMAP_AMOUNT1,IDC_COMPMAP_AMOUNTSPIN1,
						IDC_COMPMAP_AMOUNT2,IDC_COMPMAP_AMOUNTSPIN2,
						IDC_COMPMAP_AMOUNT3,IDC_COMPMAP_AMOUNTSPIN3,
						IDC_COMPMAP_AMOUNT4,IDC_COMPMAP_AMOUNTSPIN4,
						IDC_COMPMAP_AMOUNT5,IDC_COMPMAP_AMOUNTSPIN5,
						IDC_COMPMAP_AMOUNT6,IDC_COMPMAP_AMOUNTSPIN6,
						IDC_COMPMAP_AMOUNT7,IDC_COMPMAP_AMOUNTSPIN7,
						IDC_COMPMAP_AMOUNT8,IDC_COMPMAP_AMOUNTSPIN8,
						IDC_COMPMAP_AMOUNT9,IDC_COMPMAP_AMOUNTSPIN9,
						IDC_COMPMAP_AMOUNT10,IDC_COMPMAP_AMOUNTSPIN10,
						 SPIN_AUTOSCALE, 
		end, 
	end
	);



//--- BumpBlend -------------------------------------------------------
BumpBlend::BumpBlend()
{
	for (int i=0; i<NSUBTEX; i++) 
		{
		subtex[i] = NULL;
		masktex[i] = NULL;
		}
	//TODO: Add all the initializing stuff
	pblock = NULL;
	BumpBlendDesc.MakeAutoParamBlocks(this);
	Reset();
}

BumpBlend::~BumpBlend()
{

}

//From MtlBase
void BumpBlend::Reset() 
{
	//TODO: Reset texmap back to its default values

	ivalid.SetEmpty();

}

void BumpBlend::Update(TimeValue t, Interval& valid) 
{	
	//TODO: Add code to evaluate anything prior to rendering
	ivalid = FOREVER;
	for (int i = 0; i < 10; i++)
		{
		Texmap *sub;
		float u;
		pblock->GetValue(compmat_mtls,t,sub,valid,i);
		subtex[i] = sub;
		if (sub != NULL)
			{
			valid &= sub->Validity(t);
			}


		pblock->GetValue(compmat_amount,t,u,valid,i);
		amounts[i] = u/100.0f;

		BOOL on;
		pblock->GetValue(compmat_map_on,t,on,FOREVER,i);
		ons[i] = on;

		}

	for (i = 10; i < 20; i++)
		{
		Texmap *sub;
		pblock->GetValue(compmat_mtls,t,sub,valid,i);
		masktex[i-10] = sub;
		if (sub != NULL)
			{
			valid &= sub->Validity(t);
			}


		}

	valid &= ivalid;

}

Interval BumpBlend::Validity(TimeValue t)
{
	//TODO: Update ivalid here
	Interval valid = FOREVER;		
	for (int i = 0; i < 10; i++)
		{
		Texmap *sub;
		float u;
		pblock->GetValue(compmat_mtls,t,sub,valid,i);

		if (sub != NULL)
			{
			valid &= sub->Validity(t);
			pblock->GetValue(compmat_amount,t,u,valid,i);
			}
		}
	for (i = 10; i < 20; i++)
		{
		Texmap *sub;
	
		pblock->GetValue(compmat_mtls,t,sub,valid,i);

		if (sub != NULL)
			{
			valid &= sub->Validity(t);
			}
		}
//	pblock2->GetValue(compmat_type,t,currentType,ivalid);

	return valid;
}

ParamDlg* BumpBlend::CreateParamDlg(HWND hwMtlEdit, IMtlParams *imp) 
{
	IAutoMParamDlg* masterDlg = BumpBlendDesc.CreateParamDlgs(hwMtlEdit, imp, this);
	//TODO: Set the user dialog proc of the param block, and do other initialization	
	return masterDlg;	
}

BOOL BumpBlend::SetDlgThing(ParamDlg* dlg)
{	
	return TRUE;
}



//From ReferenceMaker
RefTargetHandle BumpBlend::GetReference(int i) 
{
	//TODO: Return the references based on the index	
		
	if (i==0) return pblock;
	else return NULL;
}

void BumpBlend::SetReference(int i, RefTargetHandle rtarg) 
{
	//TODO: Store the reference handle passed into its 'i-th' reference
	if (i==0)
		pblock = (IParamBlock2 *)rtarg;
}

//From ReferenceTarget 
RefTargetHandle BumpBlend::Clone(RemapDir &remap) 
{
	BumpBlend *mnew = new BumpBlend();
	*((MtlBase*)mnew) = *((MtlBase*)this); // copy superclass stuff
	//TODO: Add other cloning stuff
	return (RefTargetHandle)mnew;
}

	 
Animatable* BumpBlend::SubAnim(int i) 
{
	//TODO: Return 'i-th' sub-anim
	return pblock;
}

TSTR BumpBlend::SubAnimName(int i) 
{
	//TODO: Return the sub-anim names
	return GetString(IDS_PARAMS);
}

RefResult BumpBlend::NotifyRefChanged(Interval changeInt, RefTargetHandle hTarget, 
   PartID& partID, RefMessage message ) 
{
	//TODO: Handle the reference changed messages here	
	switch (message) {
		case REFMSG_CHANGE:
			if (hTarget == pblock)
				{
				ivalid.SetEmpty();
				bumpblend_param_blk.InvalidateUI();
				// NotifyChanged();  //DS this is redundant
				}
			else
				{
				ivalid.SetEmpty();
				NotifyDependents(FOREVER, PART_ALL, REFMSG_CHANGE);
				}
			break;
			
		}
	return(REF_SUCCEED);
}

IOResult BumpBlend::Save(ISave *isave) 
{
	//TODO: Add code to allow plugin to save its data
	return IO_OK;
}

IOResult BumpBlend::Load(ILoad *iload) 
{ 
	//TODO: Add code to allow plugin to load its data
	return IO_OK;
}

AColor BumpBlend::EvalColor(ShadeContext& sc)
{
	//TODO: Evaluate the color of texture map for the context.
	AColor p(0.0f,0.0f,0.0f,0.0f);
	if (gbufID) sc.SetGBufferID(gbufID);
    BOOL c = FALSE;
	for (int i=0; i<10; i++) {
		Interval iv;
		if (!subtex[i]||!ons[i]) continue;
		AColor d = subtex[i]->EvalColor(sc);
		float value;
		value = amounts[i];
		if (masktex[i])
			{
			value *= masktex[i]->EvalMono(sc);
			}
		if (!c) {
			p = d * value ;
			c = 1;
			}	
		else {
			// composite perturbations using alpha -- DS 4/4/97
//			AColor col = subTex[i]->EvalColor(sc);
			p = p + (d * value);
			}
		}
	return p;	

//	return AColor (0.0f,0.0f,0.0f,0.0f);
}

float BumpBlend::EvalMono(ShadeContext& sc)
{
	//TODO: Evaluate the map for a "mono" channel
	AColor p(0.0f,0.0f,0.0f,0.0f);
	if (gbufID) sc.SetGBufferID(gbufID);
    BOOL c = FALSE;
	for (int i=0; i<10; i++) {
		Interval iv;
		if (!subtex[i]||!ons[i]) continue;
		AColor d = subtex[i]->EvalColor(sc);
		float value;
		value = amounts[i];
		if (masktex[i])
			{
			value *= masktex[i]->EvalMono(sc);
			}
		if (!c) {
			p = d * value ;
			c = 1;
			}	
		else {
			// composite perturbations using alpha -- DS 4/4/97
//			AColor col = subTex[i]->EvalColor(sc);
			p = p + (d * value);
			}
		}
	return Intens(p);	

}

Point3 BumpBlend::EvalNormalPerturb(ShadeContext& sc)
{
	//TODO: Return the perturbation to apply to a normal for bump mapping
	Point3 p(0,0,0);
	if (gbufID) sc.SetGBufferID(gbufID);
    BOOL c = FALSE;
	for (int i=0; i<10; i++) {
		Interval iv;
		if (!subtex[i]||!ons[i]) continue;
		Point3 d = subtex[i]->EvalNormalPerturb(sc);
		float value;
		value = amounts[i];
		if (masktex[i])
			{
			value *= masktex[i]->EvalMono(sc);
			}
		if (!c) {
			p = d * value ;
			c = 1;
			}	
		else {
			// composite perturbations using alpha -- DS 4/4/97
//			AColor col = subTex[i]->EvalColor(sc);
			p = p + (d * value);
			}
		}
	return p;	
}

ULONG BumpBlend::LocalRequirements(int subMtlNum)
{
	//TODO: Specify various requirements for the material
	return 0;
}

